Package weka.gui.beans

# Class Associator

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
weka.gui.beans.Associator

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `EventListener`, `Accessible`, `EnvironmentHandler`, `BeanCommon`, `ConfigurationProducer`, `DataSourceListener`, `EventConstraints`, `StructureProducer`, `TrainingSetListener`, `UserRequestAcceptor`, `Visible`, `WekaWrapper`

public class Associator extends JPanel implements BeanCommon, Visible, WekaWrapper, EventConstraints, Serializable, UserRequestAcceptor, DataSourceListener, TrainingSetListener, ConfigurationProducer, StructureProducer, EnvironmentHandler
Bean that wraps around weka.associations. If used in a non-graphical environment, options for the wrapped associator can be provided by setting an environment variable: weka.gui.beans.associator.schemeOptions. The value of this environment variable needs to be a string containing command-line option settings.

Since:
  1.0
Version:
  $Revision: 10216 $
Author:
  Mark Hall (mhall at cs dot waikato dot ac dot nz)
See Also:
  - `JPanel`
  - `BeanCommon`
  - `Visible`
  - `WekaWrapper`
  - `Serializable`
  - `UserRequestAcceptor`
  - `TrainingSetListener`
  - `DataSourceListener`
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class javax.swing.JComponent

  `JComponent.AccessibleJComponent`

  ## Nested classes/interfaces inherited from class java.awt.Component

  `Component.BaselineResizeBehavior`

- ## Field Summary

  ### Fields inherited from class javax.swing.JComponent

  `TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

  ### Fields inherited from class java.awt.Component

  `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

  ### Fields inherited from interface java.awt.image.ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Associator()`
  Creates a new `Associator` instance.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `acceptDataSet(DataSetEvent e)`
  `void`
  `acceptTrainingSet(TrainingSetEvent e)`
  Accept a training set
  `void`
  `addBatchAssociationRulesListener(BatchAssociationRulesListener al)`
  Add a batch association rules listener
  `void`
  `addConfigurationListener(ConfigurationListener cl)`
  We don't have to keep track of configuration listeners (see the documentation for ConfigurationListener/ConfigurationEvent).
  `void`
  `addGraphListener(GraphListener cl)`
  Add a graph listener
  `void`
  `addTextListener(TextListener cl)`
  Add a text listener
  `boolean`
  `connectionAllowed(EventSetDescriptor esd)`
  Returns true if, at this time, the object will accept a connection according to the supplied EventSetDescriptor
  `boolean`
  `connectionAllowed(String eventName)`
  Returns true if, at this time, the object will accept a connection with respect to the named event
  `void`
  `connectionNotification(String eventName, Object source)`
  Notify this object that it has been registered as a listener with a source with respect to the named event
  `void`
  `disconnectionNotification(String eventName, Object source)`
  Notify this object that it has been deregistered as a listener with a source with respect to the supplied event name
  `Enumeration<String>`
  `enumerateRequests()`
  Return an enumeration of requests that can be made by the user
  `boolean`
  `eventGeneratable(EventSetDescriptor esd)`
  Returns true, if at the current time, the event described by the supplied event descriptor could be generated.
  `boolean`
  `eventGeneratable(String eventName)`
  Returns true, if at the current time, the named event could be generated.
  `Associator`
  `getAssociator()`
  Get the associator currently set for this wrapper
  `String`
  `getCustomName()`
  Get the custom (descriptive) name for this bean (if one has been set)
  `Instances`
  `getStructure(String eventName)`
  Get the structure of the output encapsulated in the named event.
  `BeanVisual`
  `getVisual()`
  Gets the visual appearance of this wrapper bean
  `Object`
  `getWrappedAlgorithm()`
  Returns the wrapped associator
  `String`
  `globalInfo()`
  Global info (if it exists) for the wrapped classifier
  `boolean`
  `isBusy()`
  Returns true if.
  `void`
  `performRequest(String request)`
  Perform a particular request
  `void`
  `removeBatchAssociationRulesListener(BatchAssociationRulesListener al)`
  Remove a batch association rules listener
  `void`
  `removeConfigurationListener(ConfigurationListener cl)`
  We don't have to keep track of configuration listeners (see the documentation for ConfigurationListener/ConfigurationEvent).
  `void`
  `removeGraphListener(GraphListener cl)`
  Remove a graph listener
  `void`
  `removeTextListener(TextListener cl)`
  Remove a text listener
  `void`
  `setAssociator(Associator c)`
  Set the associator for this wrapper
  `void`
  `setCustomName(String name)`
  Set a custom (descriptive) name for this bean
  `void`
  `setEnvironment(Environment env)`
  Set environment variables to use.
  `void`
  `setLog(Logger logger)`
  Set a logger
  `void`
  `setVisual(BeanVisual newVisual)`
  Sets the visual appearance of this wrapper bean
  `void`
  `setWrappedAlgorithm(Object algorithm)`
  Sets the algorithm (associator) for this bean
  `void`
  `stop()`
  Stop any associator action
  `void`
  `useDefaultVisual()`
  Use the default visual appearance for this bean

  ### Methods inherited from class javax.swing.JPanel

  `getAccessibleContext, getUI, getUIClassID, setUI, updateUI`

  ### Methods inherited from class javax.swing.JComponent

  `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

  ### Methods inherited from class java.awt.Container

  `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate`

  ### Methods inherited from class java.awt.Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Associator

    public Associator()
    Creates a new `Associator` instance.

- ## Method Details

  - ### globalInfo

    public String globalInfo()
    Global info (if it exists) for the wrapped classifier
    Returns:
      the global info

  - ### setEnvironment

    public void setEnvironment(Environment env)
    Set environment variables to use.
    Specified by:
      `setEnvironment` in interface `EnvironmentHandler`
    Parameters:
      `env` - the environment variables to use

  - ### setCustomName

    public void setCustomName(String name)
    Set a custom (descriptive) name for this bean
    Specified by:
      `setCustomName` in interface `BeanCommon`
    Parameters:
      `name` - the name to use

  - ### getCustomName

    public String getCustomName()
    Get the custom (descriptive) name for this bean (if one has been set)
    Specified by:
      `getCustomName` in interface `BeanCommon`
    Returns:
      the custom name (or the default name)

  - ### setAssociator

    public void setAssociator(Associator c)
    Set the associator for this wrapper
    Parameters:
      `c` - a `weka.associations.Associator` value

  - ### getAssociator

    public Associator getAssociator()
    Get the associator currently set for this wrapper
    Returns:
      a `weka.associations.Associator` value

  - ### setWrappedAlgorithm

    public void setWrappedAlgorithm(Object algorithm)
    Sets the algorithm (associator) for this bean
    Specified by:
      `setWrappedAlgorithm` in interface `WekaWrapper`
    Parameters:
      `algorithm` - an `Object` value
    Throws:
      `IllegalArgumentException` - if an error occurs

  - ### getWrappedAlgorithm

    public Object getWrappedAlgorithm()
    Returns the wrapped associator
    Specified by:
      `getWrappedAlgorithm` in interface `WekaWrapper`
    Returns:
      an `Object` value

  - ### acceptTrainingSet

    public void acceptTrainingSet(TrainingSetEvent e)
    Accept a training set
    Specified by:
      `acceptTrainingSet` in interface `TrainingSetListener`
    Parameters:
      `e` - a `TrainingSetEvent` value

  - ### acceptDataSet

    public void acceptDataSet(DataSetEvent e)
    Specified by:
      `acceptDataSet` in interface `DataSourceListener`

  - ### setVisual

    public void setVisual(BeanVisual newVisual)
    Sets the visual appearance of this wrapper bean
    Specified by:
      `setVisual` in interface `Visible`
    Parameters:
      `newVisual` - a `BeanVisual` value

  - ### getVisual

    public BeanVisual getVisual()
    Gets the visual appearance of this wrapper bean
    Specified by:
      `getVisual` in interface `Visible`
    Returns:
      a `BeanVisual` value

  - ### useDefaultVisual

    public void useDefaultVisual()
    Use the default visual appearance for this bean
    Specified by:
      `useDefaultVisual` in interface `Visible`

  - ### addBatchAssociationRulesListener

    public void addBatchAssociationRulesListener(BatchAssociationRulesListener al)
    Add a batch association rules listener
    Parameters:
      `al` - a `BatchAssociationRulesListener`

  - ### removeBatchAssociationRulesListener

    public void removeBatchAssociationRulesListener(BatchAssociationRulesListener al)
    Remove a batch association rules listener
    Parameters:
      `al` - a `BatchAssociationRulesListener`

  - ### addTextListener

    public void addTextListener(TextListener cl)
    Add a text listener
    Parameters:
      `cl` - a `TextListener` value

  - ### removeTextListener

    public void removeTextListener(TextListener cl)
    Remove a text listener
    Parameters:
      `cl` - a `TextListener` value

  - ### addGraphListener

    public void addGraphListener(GraphListener cl)
    Add a graph listener
    Parameters:
      `cl` - a `GraphListener` value

  - ### removeGraphListener

    public void removeGraphListener(GraphListener cl)
    Remove a graph listener
    Parameters:
      `cl` - a `GraphListener` value

  - ### addConfigurationListener

    public void addConfigurationListener(ConfigurationListener cl)
    We don't have to keep track of configuration listeners (see the documentation for ConfigurationListener/ConfigurationEvent).
    Specified by:
      `addConfigurationListener` in interface `ConfigurationProducer`
    Parameters:
      `cl` - a ConfigurationListener.

  - ### removeConfigurationListener

    public void removeConfigurationListener(ConfigurationListener cl)
    We don't have to keep track of configuration listeners (see the documentation for ConfigurationListener/ConfigurationEvent).
    Specified by:
      `removeConfigurationListener` in interface `ConfigurationProducer`
    Parameters:
      `cl` - a ConfigurationListener.

  - ### connectionAllowed

    public boolean connectionAllowed(String eventName)
    Returns true if, at this time, the object will accept a connection with respect to the named event
    Specified by:
      `connectionAllowed` in interface `BeanCommon`
    Parameters:
      `eventName` - the event
    Returns:
      true if the object will accept a connection

  - ### connectionAllowed

    public boolean connectionAllowed(EventSetDescriptor esd)
    Returns true if, at this time, the object will accept a connection according to the supplied EventSetDescriptor
    Specified by:
      `connectionAllowed` in interface `BeanCommon`
    Parameters:
      `esd` - the EventSetDescriptor
    Returns:
      true if the object will accept a connection

  - ### connectionNotification

    public void connectionNotification(String eventName, Object source)
    Notify this object that it has been registered as a listener with a source with respect to the named event
    Specified by:
      `connectionNotification` in interface `BeanCommon`
    Parameters:
      `eventName` - the event
      `source` - the source with which this object has been registered as a listener

  - ### disconnectionNotification

    public void disconnectionNotification(String eventName, Object source)
    Notify this object that it has been deregistered as a listener with a source with respect to the supplied event name
    Specified by:
      `disconnectionNotification` in interface `BeanCommon`
    Parameters:
      `eventName` - the event
      `source` - the source with which this object has been registered as a listener

  - ### isBusy

    public boolean isBusy()
    Returns true if. at this time, the bean is busy with some (i.e. perhaps a worker thread is performing some calculation).
    Specified by:
      `isBusy` in interface `BeanCommon`
    Returns:
      true if the bean is busy.

  - ### stop

    public void stop()
    Stop any associator action
    Specified by:
      `stop` in interface `BeanCommon`

  - ### setLog

    public void setLog(Logger logger)
    Set a logger
    Specified by:
      `setLog` in interface `BeanCommon`
    Parameters:
      `logger` - a `Logger` value

  - ### enumerateRequests

    public Enumeration<String> enumerateRequests()
    Return an enumeration of requests that can be made by the user
    Specified by:
      `enumerateRequests` in interface `UserRequestAcceptor`
    Returns:
      an `Enumeration` value

  - ### performRequest

    public void performRequest(String request)
    Perform a particular request
    Specified by:
      `performRequest` in interface `UserRequestAcceptor`
    Parameters:
      `request` - the request to perform
    Throws:
      `IllegalArgumentException` - if an error occurs

  - ### eventGeneratable

    public boolean eventGeneratable(EventSetDescriptor esd)
    Returns true, if at the current time, the event described by the supplied event descriptor could be generated.
    Parameters:
      `esd` - an `EventSetDescriptor` value
    Returns:
      a `boolean` value

  - ### getStructure

    public Instances getStructure(String eventName)
    Get the structure of the output encapsulated in the named event. If the structure can't be determined in advance of seeing input, or this StructureProducer does not generate the named event, null should be returned.
    Specified by:
      `getStructure` in interface `StructureProducer`
    Parameters:
      `eventName` - the name of the output event that encapsulates the requested output.
    Returns:
      the structure of the output encapsulated in the named event or null if it can't be determined in advance of seeing input or the named event is not generated by this StructureProduce.

  - ### eventGeneratable

    public boolean eventGeneratable(String eventName)
    Returns true, if at the current time, the named event could be generated. Assumes that the supplied event name is an event that could be generated by this bean
    Specified by:
      `eventGeneratable` in interface `EventConstraints`
    Parameters:
      `eventName` - the name of the event in question
    Returns:
      true if the named event could be generated at this point in time